/*
 * This code is Taken from the and it is used only for the course Advanced Programming 
 * Java the complete refeference 9th Edition
 */

import java.util.regex.*;

public class RegExpr_Wildcard_Quantifiers {
	public static void main(String[] args) {
		Pattern pat;
		Matcher mat;
		//compile the regular expression
		
		pat = Pattern.compile("W+");
		mat = pat.matcher("W WW WWW");
		while(mat.find())System.out.println("Match: "+mat.group());
		//try the following with the greedy syntax {n,m}
		pat = Pattern.compile("W{2,4}");
		mat = pat.matcher("W WW WWW");
		while(mat.find())System.out.println("Match: "+mat.group());
		//or exact match
		pat = Pattern.compile("W{2}");
		mat = pat.matcher("W WW WWW");
		while(mat.find())System.out.println("Match: "+mat.group());
		//it matches the longest sequence of char that starts with e and with d. ".+" means a seqeunce of any characer  1 or more length. 
		//It is greedy in the sense that it finds the longest sequence. 
		pat = Pattern.compile("e.+d");
		mat = pat.matcher("extend cup end table");
		while(mat.find())System.out.println("Match the longest: "+mat.group());
		//"?" means 0 or 1. In the following with ".+?" we first match any character once and then we match zero or more time any character
		pat = Pattern.compile("e.+?d");
		mat = pat.matcher("extend cup end table");
		while(mat.find())System.out.println("Match any length: "+mat.group());
		// Match lower case words qith quantifier "+" the blank space breaks the while returning false
		pat = Pattern.compile("[a-z]+");
		mat = pat.matcher("extend cup end table");
		while(mat.find())System.out.println("Match any length: "+mat.group());
		
		
		
}
}